package pl.elektrofanklub.weatherreceiver;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.view.ActionMode;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.FieldNamingPolicy;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import java.util.Date;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import retrofit.Callback;
import retrofit.RestAdapter;
import retrofit.RetrofitError;
import retrofit.client.Response;
import retrofit.converter.GsonConverter;

public class MainActivity extends AppCompatActivity implements Callback<WeatherData> {

    @BindView(R.id.temperature)
    protected TextView mTemperature;

    @BindView(R.id.humidity)
    protected TextView mHumidity;

    @BindView(R.id.time_stamp)
    protected TextView mTimeStamp;


    private WeatherInterface mAPI;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.setDebug(true);
        ButterKnife.bind(this);


        RestAdapter mRestAdapter = new RestAdapter.Builder()
                .setEndpoint("http://raspberrypi:81/")
                .setLogLevel(RestAdapter.LogLevel.FULL)
                .build();
        mAPI = mRestAdapter.create(WeatherInterface.class);

    }

    @OnClick(R.id.button_get)
    protected void getWeather()
    {
        mAPI.getData(this);
    }


    public void success(Void aVoid, Response response) {

    }

    @Override
    public void success(WeatherData weatherData, Response response) {
        mHumidity.setText(((Integer) weatherData.getHumidity()).toString());
        mTemperature.setText(((Double) weatherData.getTemperature()).toString());
        mTimeStamp.setText(weatherData.getDate() + ", " + weatherData.getTime());
    }

    @Override
    public void failure(RetrofitError error) {
        mHumidity.setText("--");
        mTemperature.setText("--");
        Toast.makeText(this, "Błąd połączenia", Toast.LENGTH_LONG).show();
    }
}
